$(document).ready(function () {
	
    // let the Category-1 div be droppable to accept images
    $('#artCat_1').droppable({
      accept: "#divUnsortImages > a, #artCat_2 > a, #artCat_3 > a",
      drop: function( event, ui ) {
        var $id = $( "#artCat_1" );
		deleteImage( ui.draggable, $id  );
      }
    });
	
	// let the Category-2 div be droppable to accept images
    $('#artCat_2').droppable({
      accept: "#divUnsortImages > a, #artCat_1 > a, #artCat_3 > a",
      drop: function( event, ui ) {
		var $id = $( "#artCat_2" );
        deleteImage( ui.draggable, $id );
      }
    });
	
	// let the Category-3 div be droppable to accept images
    $('#artCat_3').droppable({
      accept: "#divUnsortImages > a, #artCat_1 > a, #artCat_2 > a",
      drop: function( event, ui ) {
		var $id = $( "#artCat_3" );
        deleteImage( ui.draggable, $id );
      }
    });
	
	// let the divUnsortImages div be droppable to accept images back from the category divs
    $('#divUnsortImages').droppable({
      accept: "#artCat_1 > a, #artCat_2 > a, #artCat_3 > a",
      drop: function( event, ui ) {
		var $id = $( "#divUnsortImages" );
        deleteImage( ui.draggable, $id );
      }
    });
	
	function deleteImage( $item, $dropID ) {
	$item.fadeOut(function(){
      $item.find('a').end().appendTo( $dropID ).fadeIn();     
	  });
    }
	
	$.ajax({
        type: "GET",
        url: "sort_XML/DB_Lindera_with_names.xml",
        dataType: "xml",
        success: function (xml) {
            var chkCount = $(xml).find('IMAGE').length;
			var arrCat = [];				
			var allImages = [];
			hashTable = {};
			
			
			$(xml).find('IMAGE').each(function(){				
				var id=$(this).find('ID').text();
				var name=$(this).find('NAME').text();
				var cat=$(this).find('CATEGORY').text();
				var loc=$(this).find('LOCATION').text();
				var imgPath = loc + '/' + name;				
				
				if($.inArray(cat,arrCat) == -1)
				{
					arrCat.push(cat);
					hashTable[cat] = 1;
				}
				else
					hashTable[cat] += 1;
					
				allImages.push(ImageData(imgPath,cat));
				
				
			});
			
			var minVal = 0;
			var minCat;
			$.each(hashTable,function(key,value){
				if(minVal == 0){
					minVal = value;
					minCat = key;
				}
				else{
					if(minVal > value){
						minVal = value;
						minCat = key;
					}
				}			
            });
			
			$('#lblCat_1').text(arrCat[0]);
			$('#lblCat_2').text(arrCat[1]);
			$('#lblCat_3').text(arrCat[2]);
			var dispImages = [];
			var arrCatAdded = [];
			hashTableNew = {};
			
			for(var i = dispImages.length;i < (arrCat.length*minVal);i++)
			{
				tempImage = allImages[Math.floor(Math.random() * allImages.length)];	//randomly pick an image from the array
								
				if(typeof(hashTableNew[tempImage.categ]) === "undefined")	//if the hashtable does not contains a value corresponding to the category, add it
					hashTableNew[tempImage.categ] = 1;
				//if the category does not exists in arrCatAdded(used to store categories which have number of elements equal to minVal) and 
				//hashtable contains a value corresponding to the category then add 1 to the hashtable value
				else if($.inArray(tempImage.categ,arrCatAdded) === -1) 	
					hashTableNew[tempImage.categ] += 1;
					
				if($.inArray(tempImage.categ,arrCatAdded) === -1)
				{					
					if(hashTableNew[tempImage.categ] < minVal) 
						dispImages.push(tempImage);	//if value of category items in hashtable is less than minVal then add this image into the dispImages array
					else if(hashTableNew[tempImage.categ] === minVal)
					{
						//if value of category items in hashtable is equal to minVal, then add that image into dispImages and also add this category into arrCatAdded
						dispImages.push(tempImage);
						arrCatAdded.push(tempImage.categ);
					}
				}
				else{i -= 1;}	//if category already exists in arrCatAdded, then dont increase the value of loop variable
								
				allImages.splice(allImages.indexOf(tempImage),1);	//remove the picked image from the array so that it does not repeats
			}
						
			var totalImages = 0;
			$(dispImages).each(function(){
				totalImages += 1;
				$('<a class="group1" href="' + this.path.replace('.jpg','_l.jpg') + '"><img  src="' + this.path + '" /></a>').data('cat',this.categ).appendTo('#divUnsortImages').draggable( {
				  containment: '#wrapper',		//Uses containment to constrain it to the #wrapper div
				  helper: 'clone',
				  cursor: 'move',	//Uses cursor to turn the mouse cursor into a move cursor during the drag
				  distance: 10,	//Distance in pixels after mousedown the mouse must move before dragging should start. Used to prevent unwanted drags.
				  opacity: 0.9,	//Opacity of the helper while dragging
				  cursorAt: {left: 40, top: 40}				  
				 });
			});
			$('#hidTotal').val(totalImages);
		}});
	
    //Code for reading XML Ends
	
	$('#divUnsortImages').on("click", ".group1", function() {
		$.extend($.colorbox.settings, {width:'500px', height:'750px'});
		$(".group1").colorbox({rel:'group1'});
	});
	
	$('#artCat_1').on("click", ".group1", function() {
		$.extend($.colorbox.settings, {width:'500px', height:'750px'});
		$(".group1").colorbox({rel:'group1'});
	});
	
	$('#artCat_2').on("click", ".group1", function() {
		$.extend($.colorbox.settings, {width:'500px', height:'750px'});
		$(".group1").colorbox({rel:'group1'});
	});		
	
	$('#artCat_3').on("click", ".group1", function() {
		$.extend($.colorbox.settings, {width:'500px', height:'750px'});
		$(".group1").colorbox({rel:'group1'});
	});	
});

$('#btnSubmit').click(function(){
	var counter = 0;
	var total = 0;
	$('#artCat_1').find('a').each(function(){
		total+=1;
		if($(this).data('cat') == 'Lindera benzoin')
		{
			counter+=1;			
		}
	});
	$('#artCat_2').find('a').each(function(){
		total+=1;
		if($(this).data('cat') == 'Lindera melissifolia')
		{
			counter+=1;			
		}
	});
	$('#artCat_3').find('a').each(function(){
		total+=1;
		if($(this).data('cat') == 'Lindera subcoriacea')
		{
			counter+=1;			
		}
	});
	var incorrect = total - counter;
	var unanswered = parseInt($('#hidTotal').val()) - total; 
	var percent = Math.round((counter / (incorrect+counter)) * 100);
	
	var htmlCont = '<span id="inline_content">';
	htmlCont += '<h2><u>Your Score</u></h2><br><br>';
	htmlCont += '<strong>Not Answered: </strong>'+unanswered;
	htmlCont += '<br><br><strong>Total Answered: </strong>'+total;
	htmlCont += '<br><br><strong>Correct Answers: </strong>'+counter;
	htmlCont += '<br><br><strong>Incorrect Answers: </strong>'+incorrect;	
	htmlCont += '<br><br><strong>Percentage Correct: </strong>'+ percent +'%';
	htmlCont += '<br><br><button id="btnReturn">Return</button>';
	htmlCont += '&nbsp;&nbsp;<button id="btnReset">Reset</button></span>';
	$.extend($.colorbox.settings, {width:'300px', height:'420px'});
	$.colorbox({html:htmlCont});	
	
	
	$('#btnReturn').on("click", function() {
		$(window).colorbox.close();
	});
	
	$('#btnReset').on("click", function() {
		$(window).colorbox.close();
		parent.location.reload();
	});
});

$('#btnClear').click(function(){
	$('#artCat_1,#artCat_2,#artCat_3').find('a').each(function(){
		$(this).detach();
		$(this).appendTo('#divUnsortImages');		
	});
});

function ImageData(path,categ){
	return {
	  path:path,
	  categ:categ
	}
}


